
# Channel command kit

# Distributable version

# If you encounter any problems(not the actions section) please mail
# your question and as much details of problem as possible to
# cmouse@fiiu.org - Please attach also any description of the situation
# or command where this happened. Also attach your user flags with it.
# It is the mode string you get when you type .whois
# example
#  .whois cmouse
# [16:41] #cmouse# whois cmouse
# HANDLE    PASS NOTES FLAGS           LAST
# cmouse    yes      0 fhjmnoptxZ      15:56 (partyline )
# #teddybears        fmno            15:48
# #nexus     

# GREETS TO THE MAKER OF THE AI-LIVINGBOT SCRIPT

# these define what to return for $trigger and binds

# If you want to use this script on more than one bots
# then comment the next line out and add the line
# to bots config
# example:
# set trigger "codem"
# source scripts/toolscript.tcl

set trigger "codem"

proc cmd:trig {} {
    global trigger
    return $trigger
}

# Unbinds seen again

unbind pub - "seen" *pub:seen

# Word Kick List
set badwords "badwords"

# Is the word kick sentry defaulted to on or off [1/0]
set badworddef 0

# Topic list file, default is topic.your_bot_nick
set topicfile "topics.$trigger"

# We need a script to use as a talking scrip
# if ya have none... then I suggest you use this one
# Put here your own OTHER scripts for use.
# IF you use another script, then you MUST change
# the script from below. If you do not wish the bot to talk
# at all, comment out the next line and change the
# value of the replyonfailure to 0

source scripts/ai-livingbot.3.tcl

set replyonfailure 1

# here you can put other scripts for use. Remember to bind 
# them on the script if needed.

source scripts/sanakirja.tcl

# Command prefix - I recommend that you use a name here
# Default is your bot's nick on IRC
# You also need to change the bindings to match the trigger
# as it's not done automatically

# Change this to your trigger if you don't want to use bot's nick

bind pubm -|- "% [cmd:trig]*" cmd:switch
# Select from these a nice error message if user msg's your bot with these

#bind msg -|- "[cmd:trig]" cmd:yesimhere
bind msg -|- "[cmd:trig]" cmd:nothere

# Allow this to use * Botnick did something from dcc chat
bind dcc -|o "action" dcc:action

# Allow unknown users
set cmdallow 1

# Require authentication for admin commands
set cmdauth 1




# Do not modify ANYTHING below, unless you know what your doing!



# Some notices to "stupid" users

bind msg - "auht" cmd:useauth

# Authentication
bind msg -|- "auth" cmd:auth

# Deauthentication
bind part -|- "*" cmd:deauth
bind sign -|- "*" cmd:deauth_sign
bind kick -|- "*" cmd:deauth
bind pubm -|- "*" cmd:sentryscanner

timer 1 cmd:makesentryup

# The code begins here - No need to look below

# For TCL programmers who wish to add stuff I have added some info.
# Channel commands go to the FIRST switch in cmd:switch
# User commands go to the proc cmd:usermanager
# Other commands go to the SECOND switch in cmd:switch
# You can use your own scripts. Make sure you don't
# have any binds in the script enabled(unless you want
# to have double access to commands). 
# The comments explain the scripts functions and what they return
# values are. Read them.


# Make sure that files do exist

if {![file exists $topicfile]} {
    set newfile [open $topicfile w]
    puts $newfile ""
    close $newfile
}

proc cmd:makesentryup {} {
    global badworddef sentryup
    foreach chan [channels] {
	set sentryup([string tolower $chan]) $badworddef
    }
    set sentryup(#testsite) 1
    set sentryup(#testpriva) 1
}

# The authentication functions and some minors...

# This function just tells a user who makes a common typo auht to use auth
# Protects password from showing up on the console
# And the CodeM stuff, to tell them NOT to use /msg to cmd bot

proc log { nick handle errkey chan cmd target } {
    global cmdauth  
    switch $errkey {
	0 {
            putcmdlog "$nick\[$handle\] $cmd $target at $chan"
	}
	1 {
	    putcmdlog "$nick\[$handle\] Authed"
	}
	2 {
	    putcmdlog "ERROR $nick\[$handle\] has no password!"
	}
	3 {
	    putcmdlog "ERROR $nick\[$handle\] used wrong password!"
	}
	4 {
	    putcmdlog "ERROR $nick\[$handle\] tried to auth, thus unknown!"
	}
	5 {
	    putcmdlog "$nick\[$handle\] Deauthed"
	}
	6 {
	    putcmdlog "ERROR $nick\[$handle\] used $cmd, but had not authed yet"
	}
	7 {
	    putcmdlog "SECURITY ERROR $nick\[$handle\] tried to use $cmd on $chan, but doesn't have the power"
	}
	8 {
	    putcmdlog "SECURITY ERROR $nick\[$handle\] tried to use $cmd on $chan, but is not known"
	}
	9 {
	    putcmdlog "$nick\[$handle\] used illegal word on $chan"
	}
	10 {
	    putcmdlog "ERROR $nick\[$handle\] tried to use $cmd on protected user $target at $chan"
	}
	11 {
            putcmdlog "NOTE $nick\[$handle\] used power command $cmd to $target at $chan"
	}
	12 {
            putcmdlog "NOTE $nick\[$handle\] is a bot trying to use me"
	}
	13 {
	    putcmdlog "$nick\[$handle\] used $cmd at $chan"
	}
    }
}

proc cmd:yesimhere { nick idx handle args } {
    global trigger
    puthelp "NOTICE $nick :Yes, I'm here... (use without $trigger)"
    return 0
}

proc cmd:nothere { nick idx handle args } {
    global trigger
    puthelp "PRIVMSG $nick :This is not a MSG bot, use $trigger -commands on the channel!"
    return 0
}

proc cmd:useauth {nick idx handle args} {
   global trigger
   puthelp "NOTICE $nick :Use /msg $trigger auth instead"
   return 0
}

# Authenticates user. Sets users xtra auth to yes on success, no on failure

proc cmd:auth {nick idx handle args} {
    setuser $handle XTRA "AUTH" "NO"
    if {[matchattr $handle "+b"]} {
       puthelp "NOTICE $nick :Now why should a bot use toolscript?"
       log $nick $handle 12 "" "auth" ""
       return 0
    }
    # It's not nice if the user has no password.
    # Any password is valid in that case, let's take
    # care of that, shall we.
    if {$handle=="*"} {
	puthelp "NOTICE $nick :Who the hell are you?!?"
	log $nick $handle 4 "" "" ""
	return 0
    }
    if {[passwdok $handle ""]} {
	puthelp "NOTICE $nick :Failed - please set your password" 
	log $nick $handle 2 "" "" ""
	return 0
    }
  if {![passwdok $handle $args]} {
     puthelp "NOTICE $nick :Failed - check your password"
     log $nick $handle 3 "" "" ""
     return 0
  }

 # Set XTRA info on user
 # As it's not on USERINFO.TCL this is
 # changeable on console(if you don't have .tcl).

 setuser $handle XTRA "AUTH" "YES"
 log $nick $handle 1 "" "" ""
 puthelp "NOTICE $nick :Authed"
}

# Deauthenticating user as he leaves, if not on any channel

proc cmd:deauth_sign { nick idx handle channel args } {
    if {($handle=="*")||(![cmd:checkauth $handle])} { return 0 }
    setuser $handle XTRA "AUTH" "NO"
    log $nick $handle 5 "" "" ""
    return 0
}

proc cmd:deauth {nick idx handle channel args} {
    if {($handle=="*")||(![cmd:checkauth $handle])} {return 0}
    foreach chan [channels] { if {([onchan $nick $chan]==1)&&($chan!=$channel)} { return 0 } }
    setuser $handle XTRA "AUTH" "NO"
    log $nick $handle 5 "" "" ""
    return 0
}

# Check if user is authed. Return 0 if not.

proc cmd:checkauth {handle} {
 if {[getuser $handle XTRA "AUTH"]=="YES"} {
  return 1
 } else {
  return 0
 }
}

# Makes a list turn to a string, it must be magic...
# returns the string of coz

proc cmd:listtostring {list belem selem} { 
 set ret [lrange $list $belem $selem]
 return "$ret"
}

# The main "switching" program. Selects the suitable
# subprogram according to user parameters. Returns 0 at all times
# To here you can place bindings for your commands. Please notice
# the global masks such as *op which binds to deop, op, lop etc.
# in these cases, place your non-masked cmd's BEFORE the global *op
# so it'll work. 

proc cmd:switch {nick idx handle channel cmdstr} {
 global cmdallow cmdauth dictclosed replyonfailure owner
 # Some nice checks, like is it a bot, or allowed or something...
 # Also init cmdstr
 if {[matchattr $handle "+b"]} {
        log $nick $handle 12 $channel "" ""
        return 0
 }
 set cmdstr [lrange $cmdstr 1 end]
 if {[llength $cmdstr] == 0} {
     cmd:imhere $nick $channel
     return 0
 }
 if {($cmdallow == 0)&&($handle=="*")} {
     do_8ball_chan $nick $idx $handle $channel $cmdstr
     return 0
 }
 set argn 0
 set args(1) ""
 set args(2) ""
 set aargs {}
 foreach arg $cmdstr {
  incr argn
  set args($argn) [string tolower $arg]
 }

# This is needed to monitor successfull command

set success 0

# Channel modes and actions, standard stuff. More or less self describing...
# Please notice the -glob parameter that allows us to use * and ? prefix
# PUT THE SPECIFIC BEFORE THE NON-SPECIFICS!

 switch -glob -- $args(1) {
  "help" {
   cmd:help $args(2) $channel $nick
   set success 1
  }
  "opme" {
   cmd:chanmodes $args(1) $nick "reason" $channel $handle $nick
   set success 1
  }
  "refresh" {
      if {[string tolower $args(2)]=="topic"} {
	  cmd:refresh $nick $handle $channel
	  log $nick $handle 13 $channel "refresh topic" ""
	  set success 1
      }
  }
  "topic" {
   if {[string tolower $args(2)]=="refresh"} { 
      cmd:refresh $nick $handle $channel
      log $nick $handle 13 $channel "topic refresh" ""
   } else {
      cmd:chanmodes $args(1) $nick [cmd:listtostring $cmdstr 1 end] $channel $handle $nick
   }
   set success 1
  }
  "kick" {
   cmd:kickass $args(2) [cmd:listtostring $cmdstr 2 end] $channel $handle $nick
   set success 1
  }
  "kickban" {
   cmd:chanmodes $args(1) $args(2) [cmd:listtostring $cmdstr 2 end] $channel $handle $nick
   set success 1
  }
  "seen" {
   *pub:seen $nick $idx $handle $channel $args(2)
   set success 1
  }
  "*op" {
   cmd:chanmodes $args(1) $args(2) "reason" $channel $handle $nick
   set success 1
  }
  "*voice" {
   cmd:chanmodes $args(1) $args(2) "reason" $channel $handle $nick
   set success 1
  }
  "*ban" {
   cmd:chanmodes $args(1) $args(2) [cmd:listtostring $cmdstr 2 end] $channel $handle $nick
   set success 1
  }
  "sentry" { 
      cmd:sentry $nick $handle $channel $args(2) [cmd:listtostring $cmdstr 2 end]
      return 0
  }
}

# and here we check the rest. I just want to make a line between channel
# admin and channel toy commands. Again notice the -glob.

switch -glob -- $args(1) {
    "motd" {
	pub:motd $nick $idx $handle $channel $cmdstr
        log $nick $handle 13 $channel "motd" ""
	set success 1
    }
    "give" {
	cmd:give $args(2) [cmd:listtostring $cmdstr 2 end] $channel $nick
        log $nick $handle 0 $channel $cmd $args(2)
	set success 1
    }
    "quote" {
	*pub:showquote $nick $idx $handle $channel $args(2)
        log $nick $handle 13 $channel $cmd $args(2)
        set success 1
    }
    "user" {
	cmd:manager $args(2) [cmd:listtostring $cmdstr 2 end] $channel $nick $handle
	set success 1
    }
    "whois" {
	set n2h [nick2hand $args(2) $channel]
	if {($n2h=="*")||($n2h=="")} {puthelp "NOTICE $nick :I don't know $args(2)" } else { puthelp "NOTICE $nick :$args(2) is known to me as [nick2hand $args(2) $channel]" }
	set success 1
    }
    "book.close(now)" {
	if {![matchattr $handle "n"]} { return 0 }
	set dictclosed 1
       	puthelp "NOTICE $nick :Dictionary closed"
	log $nick $handle 13 $channel $args(1) ""
	set success 1
    }
    "book.open(now)" {
	if {![matchattr $handle "n"]} { return 0 }
	set dictclosed 0
	puthelp "NOTICE $nick :Dictionary opened"
	log $nick $handle 13 $channel $args(1) ""
	set success 1
    }
    "silence" {
	if {![matchattr $handle "|+n" $channel]} { 
	    puthelp "NOTICE $nick :Command unavailable"
	    return 0 
	}
	putquick "MODE $channel +m"
	puthelp "NOTICE $nick :Channel silenced, voiced channel owners"
	set tres 0
	set mdstring "MODE $channel +v+v+v "
	foreach ppl [chanlist $channel "|+m"] {
	    incr tres
	    set mdstring "$mdstring $ppl"
	    if {$tres==3} {
		puthelp $mdstring
		set mdstring "MODE $channel +v+v+v "
		set tres 0
	    }
	}
	puthelp $mdstring
	set mdstring "MODE $channel -v-v-v "
	set tres 0
	foreach ppl [chanlist $channel "|-m"] {
	    incr tres
	    set mdstring "$mdstring $ppl"
	    if {$tres==3} {
		puthelp $mdstring
		set mdstring "MODE $channel -v-v-v "
		set tres 0
	    }
	}
	puthelp $mdstring
	unset mdstring tres
        log $nick $handle 13 $channel $args(1) ""
	set success 1
    }
    "unsilence" {
	if {![matchattr $handle "|+n" $channel]} {return 0}
	putquick "MODE $channel -m"
	puthelp "NOTICE $nick :Silence removed from channel"
        log $nick $handle 13 $channel $args(1) ""
	set success 1
    }
    "mute" {
        if {![matchattr $handle "n"]} { return 0 }
	puthelp "NOTICE $nick :Muted"
        log $nick $handle 13 $channel $args(1) ""
        set replyonfailure 0
	set success 1
    }
    "unmute" { 
        if {![matchattr $handle "n"]} { return 0 }
	puthelp "NOTICE $nick :Unmuted"
        log $nick $handle 13 $channel $args(1) ""
        set replyonfailure 1
	set success 1
    }
    "explain" {
	dict:explain $nick $idx $handle $channel [cmd:listtostring $cmdstr 1 end]
        log $nick $handle 13 $channel $args(1) ""
	set success 1
    }
    "learn" {
	dict:addword $nick $idx $handle $channel [lrange $cmdstr 1 end]
        log $nick $handle 13 $channel $args(1) ""
	set success 1
    }
    "forget" {
	dict:delword $nick $idx $handle $channel [cmd:listtostring $cmdstr 1 end]
        log $nick $handle 13 $channel $args(1) ""
	set success 1
    }
    "relearn" {
	dict:modword $nick $idx $handle $channel [cmd:listtostring $cmdstr 1 end]
        log $nick $handle 13 $channel $args(1) ""
	set success 1
    }
    "gamble" {
	cmd:gamble $nick $handle $channel
        log $nick $handle 13 $channel $args(1) ""
	set success 1
    }
    "powerkick" {
	if {[getuser $handle xtra powercmd]!="YES"} { return 0 }
	if {[onchan $args(2) $channel]==0} {
	    puthelp "NOTICE $nick :No $args(2) on $channel!"
	    return 0
	}
	putserv "KICK $channel $nick :[cmd:listtostring $cmdstr 2 end]"
	log $nick $handle 11 $channel $args(1) $args(2)
	set success 1
    }
    "bedspell" {
	if {[getuser $handle xtra powercmd]!="YES"} { return 0 }
	if {[onchan $args(2) $channel]==0} { 
	    puthelp "NOTICE $nick :No $args(2) on $channel!"
	    return 0
	} else {
	    set bedhost [maskhost [getchanhost $args(2) $channel]]
	    newchanban $channel $bedhost $handle "Nukkumaan" 360
            log $nick $handle 11 $channel $args(1) $args(2)
	    set success 1
	}
    }
}

# This is the final check, it looks for the nice spank, burn etc. commands.

if {$success==0} { set success [cmd:doaction $args(1) [cmd:listtostring $cmdstr 1 end] $channel $nick] }

# Nothing found, reply something... if allowed

if {($success==0)&&($replyonfailure==1)} { 
    do_8ball_chan $nick $idx $handle $channel $cmdstr 
    return 0
} else {
    return 0
}
return 0
}

# Help section - It depends on your modes what you will be able to see
# You must also ask for the apropriate section. 
# Sections are channel, sentry, user and misc

proc cmd:help {section channel nick} {
    global botnick trigger
    set handle [nick2hand $nick $channel] 
    puthelp "NOTICE $nick :Toolscript v1.0 help"
    set master 0
    set op 0
    set owner 0
    set gowner 0
    # chanowner
    if {[matchattr $handle "|n" $channel]} { set owner 1 }
    # global owner
    if {[matchattr $handle "n"]} { set gowner 1 }
    # master(global/chan)
    if {([matchattr $handle "m"])||([matchattr $handle "|m" $channel])} { set master 1 } 
    # op
    if {([matchattr $handle "o"])||([matchattr $handle "|o" $channel])} { set op 1 }
    if {$section==""} {
	puthelp "NOTICE $nick :You can use the following sections of this script"
	if {$master} { puthelp "NOTICE $nick :user - user list manipulation commands" }
	if {$op} { puthelp "NOTICE $nick :channel - channel commands" }
	if {$owner} { puthelp "NOTICE $nick :sentry - word sentry" }
	puthelp "NOTICE $nick :misc - miscellancelous commands"
	puthelp "NOTICE $nick :Type $trigger help <section> to get commands for specific section"
	puthelp "NOTICE $nick :All commands starts with $trigger"
        log $nick $handle 0 $channel "help" $section
	return 0
    }
    set section [string tolower $section]
    if {($section=="channel")&&(($master)||($op))} {
	puthelp "NOTICE $nick :Channel commands"
	puthelp "NOTICE $nick :op <nick> - give nick channel operator status"
	puthelp "NOTICE $nick :opme - gives you ops(if you can have them)"
	puthelp "NOTICE $nick :deop <nick> - removes operator status from nick"
	puthelp "NOTICE $nick :voice <nick> - gives +v to nick(useful only if +m set for channel"
	puthelp "NOTICE $nick :devoice <nick> - removes +v from nick"
	puthelp "NOTICE $nick :kick <nick> <reason> - kicks nick from channel"
	puthelp "NOTICE $nick :kickban <nick> <reason> - kickbans nick from channel"
        puthelp "NOTICE $nick :domainban <domain> - example domainban *.inet.fi"
	puthelp "NOTICE $nick :ban <hostmask> <reason> - adds a ban to channel"
        puthelp "NOTICE $nick :shortban <nick> <reason> - 10 minute ban"
	puthelp "NOTICE $nick :unban <hostmask> - removes a existing ban"
	puthelp "NOTICE $nick :listban - lists all bans"
	puthelp "NOTICE $nick :topic <topic/refresh> - sets channel topic/refresh"
        log $nick $handle 0 $channel "help" $section
	return 0
    }
    if {($section=="user")&&($master)} {
	puthelp "NOTICE $nick :Userlist handling commands - The script will"
	puthelp "NOTICE $nick :attempt to change nicks to handle"
	puthelp "NOTICE $nick :<nick> add (as <handle/bot>) - adds a user"
	puthelp "NOTICE $nick :    The as part is needed for some people"
	puthelp "NOTICE $nick :    who need a specific handle."
	puthelp "NOTICE $nick :    Using the bot tells to add the user as"
	puthelp "NOTICE $nick :    a bot."
	puthelp "NOTICE $nick :<handle> delete - deletes user(global master only)"
	puthelp "NOTICE $nick :<handle> info - shows you information on user"
	puthelp "NOTICE $nick :<handle> modes <modestring> ?channel?- sets users modes"
	puthelp "NOTICE $nick :<handle> addhost <hostmask> - Adds a hostmask to user"
	puthelp "NOTICE $nick :<handle> delhost <hostmask> - Deletes a hostmask from user"
	puthelp "NOTICE $nick :<handle> hostlist - Lists users hosts"
	return 0
    }
    if {($section=="sentry")&&($owner)} {
	puthelp "NOTICE $nick :Word sentry controlling commands"
	puthelp "NOTICE $nick :add <word>"
	puthelp "NOTICE $nick :delete <word>"
	puthelp "NOTICE $nick :list ?mask?"
	puthelp "NOTICE $nick :start"
	puthelp "NOTICE $nick :stop"
        log $nick $handle 0 $channel "help" $section
	return 0
    }
    if {$section=="misc"} {
	puthelp "NOTICE $nick :Miscellancelous commands"
	puthelp "NOTICE $nick :give <nick> <item> - Offers item to nick"
	puthelp "NOTICE $nick :whois <nick> - Shows nick's handle(if has one)"
	puthelp "NOTICE $nick :explain <word> - Tries to explain a word from it's dictionary"
	if {[matchattr $handle "+Z"]} {
	   puthelp "NOTICE $nick :learn <word>=<explanation> - dictionary(need +Z)"
	   puthelp "NOTICE $nick :forget <word> - dictionary(need +Z)"
	   puthelp "NOTICE $nick :relearn <word>=<explanation> - dictionary(need +Z)"
        }
        if {$gowner} {
           puthelp "NOTICE $nick :book.close(now) - closes dictionary"
           puthelp "NOTICE $nick :book.open(now) - opens dictionary"
	   puthelp "NOTICE $nick :mute - the bot won't reply on failed commands"
           puthelp "NOTICE $nick :unmute - self-explanatory"
	}
	puthelp "NOTICE $nick :spank, kiss, kill, etc. <nick> - Actions to be done on nick"
        log $nick $handle 0 $channel "help" $section
	return 0
    }
    puthelp "NOTICE $nick :No such topic!"
    return 0
}

# User manager - command target handle/bot $modes $channel
# returns 0
 
proc cmd:manager {command params channel nick handle} {
    if {$handle=="*"} {
        log $nick $handle 8 $channel "user $command" ""
	puthelp "NOTICE $nick :Security violation detected, access denied"
	return 0
    }
    global cmdauth botnick owner
    # We create the $args(n) structure here
    set args(1) ""
    set args(2) ""
    set args(3) ""
    set args(4) ""
    set paramn 1
    foreach param $params {
	incr paramn
	set args($paramn) $param
    }
    # Here is a "cheap" solution. I used 
    # add <nick> first. Then I changed it to a <nick> add
    # So watch it being swapped
    set args(1) $args(2)
    set args(2) $command
    set command $args(1)

    # And here... we don't want to use our own bot as a target

    if {[string tolower $args(1)]==[string tolower $botnick]} {
	putserv "NOTICE $nick :I don't want to use myself..."
	return 0
    }
    # auth check..
    if {$cmdauth==1} {
	if {![cmd:checkauth $handle]} {
            log $nick $handle 6 $channel $command $args(2)
	    putserv "NOTICE $nick :You have not authed!"
	    return 0
	}
    }
    # level check
    if {!([matchattr $handle "m"] || [matchattr $handle "|m" $channel])} {
        log $nick $handle 7 $channel $command $args(2)
	putserv "NOTICE $nick :You can't do this!"
	return 0
    }
    set tnick $args(2)
    set target [cmd:nick2hand $args(2) $channel]

    # If target is a bot owner, then we refuse to use it. Security.

    if {([matchattr $target "n"])&&(![matchattr $handle "+n"])} {
       log $nick $handle 10 $channel $command $target
       puthelp "NOTICE $nick :Owners can only be changed by owners"
       return 0
    }
    if {([lsearch $target $owner]>-1)&&([lsearch $handle $owner]==-1)} {
       log $nick $handle 10 $channel $command $target
       puthelp "NOTICE $nick :Permanent owners can only be changed by permanent owners"
       return 0
    }   
    if {(($target=="")||($target=="*"))&&($command!="add")} { 
	puthelp "NOTICE $nick :I don't know any $tnick" 
	return 0
    }
    if {$paramn<3} { 
	set args(4) ""
    }
    
    log $nick $handle 0 $channel $command "$nick\[$handle\]"

    # The controlling commands, no matching

    switch -exact $command {
	"add" {
	    if {($target!="")&&($target!="*")} { 
		puthelp "NOTICE $nick :$tnick is on bot database as $target" 
		return 0
	    } else {
		set target ""
	    }
	    if {($args(4)!="bot")&&($args(4)!="")} {set target $args(4)}
	    if {$target==""} { set target [cmd:makehandle $tnick] }
	    set mhost [getchanhost $tnick $channel]
	    if {$args(4)!="bot"} {
		if {$mhost==""} {
		    adduser $target
		    puhelp "NOTICE $nick :User $target added without hostmask"
		} else {
		    adduser $target "[maskhost $mhost]"
		    puthelp "NOTICE $nick :User $target added"
		    puthelp "NOTICE $tnick :You have been added to $botnick"
		}
	    } else {
		set target [cmd:makehandle $tnick]
		addbot $target "set.this.com:3333"
		setuser $target hosts "$tnick![getchanhost $tnick $channel]"
		puthelp "NOTICE $nick :Bot $target added"
	    }
	}
	"delete" {
	    if {![matchattr $handle "+m"]} { 
		puthelp "NOTICE $nick :Global master only"
                log $nick $handle 7 $channel $command $target
		return 0 
	    }
	    deluser $target
	    puthelp "NOTICE $nick :User $target has been removed"
	}
	"modes" {
	    if {$args(4)!=""} { 
		if {[string first "|" $args(3)]<0} { set args(3) "|$args(3)" }
	    }
	    # Check the modes for overexceedings...
	    set ml1 [lindex [split $args(3) "|"] 0]
	    set ml2 [lindex [split $args(3) "|"] 1]
	    if {(!($ml1==""))&&([matchattr $handle "m"]==0)} {
                puthelp "NOTICE $nick :Format is $botnick user $args(2) modes $args(3) #channel"
		puthelp "NOTICE $nick :You may NOT use global modes"
		putcmdlog "ERROR: $handle\[$nick\] forgot channel from modes on $channel"
		return 0
	    }
	    if {([string match "*n*" $ml1]==1)&&(![matchattr $handle "n"])} {
		    puthelp "NOTICE $nick :No can do ..."
                    log $nick $handle 7 $channel "mode\(global) +n" $target
		    return 0
	    }
	    if {(!($ml2==""))&&([string match "*n*" $ml2]==1)&&(![matchattr $handle "|+n" $args(4)])&&(![matchattr $handle "|+m" $args(4)])&&(![matchattr $handle "+n"])} {
		puthelp "NOTICE $nick :Try to be a owner of the channel first..."
                log $nick $handle 7 $channel "mode\($channel) +n" $target
		return 0
	    }
	    if {($args(4)=="")} {
		chattr $target $args(3)
		puthelp "NOTICE $nick :User $target modes"
		puthelp "NOTICE $nick :-- Global modes: [chattr $target]"
	    } else {
		    chattr $target $args(3) $args(4)
		    puthelp "NOTICE $nick :User $target modes"
		    puthelp "NOTICE $nick :-- Global modes: [chattr $target]"
		    if {$args(4)!=""} { puthelp "NOTICE $nick :-- $args(4) modes: [lindex [split [chattr $target $args(4)] "|"] 1]" }
		}	    
	    }
	"addhost" {
	    set hostlist [getuser $target hosts]
            if {[lsearch -exact $hostlist $args(3)]>-1} {
                puthelp "NOTICE $nick :Host $args(3) for user $target exists"
                puthelp "NOTICE $nick :Use another hostmask"
                return 0
            }
            setuser $target hosts $args(3)
	    puthelp "NOTICE $nick :Added $args(3) to $target"
	}
        "delhost" {
            set hostlist [getuser $target hosts]
            if {[lsearch -exact $hostlist $args(3)]==-1} {
                puthelp "NOTICE $nick :Host $args(3) for user $target is invalid"
                puthelp "NOTICE $nick :Use some other host"
                return 0
            }
            delhost $target $args(3)
	    puthelp "NOTICE $nick :Host $args(3) deleted from $target"
        }
        "hostlist" {
            set hostlist [getuser $target hosts]
            puthelp "NOTICE $nick :Host listing for $target"
            foreach host $hostlist {
                puthelp "NOTICE $nick :$host"
            }
            puthelp "NOTICE $nick :--End of list--"
        }
	"list" {
	    set users [userlist $channel]
	    puthelp "NOTICE $nick :User list for $channel ([llength $users] users)"
	    foreach user $users {
		set chanowner 0
		set chanmaster 0
		set chanop 0
		set chanmodes [chattr $user $channel]
		set chamodes [lindex [split $chanmodes "|"] 1]
		if {[string match "*n*" $chanmodes]} { set chanowner 1 }
		if {[string match "*m*" $chanmodes]} { set chanmaster 1 }
		if {[string match  "*o*" $chanmodes]} { set chanop 1 }
		if {$chanowner==1} { 
		    puthelp "NOTICE $nick :$user (is a channel owner)" 
		} else {
		    if {$chanmaster==1} {
			puthelp "NOTICE $nick :$user (is a channel master)"
		    } else {
			if {$chanop==1} {
			    puthelp "NOTICE $nick :$user (is a channel operator)"
			} else { puthelp "NOTICE $nick :$user" }
		    }
		}
	    }
	}
	"info" {
	    puthelp "NOTICE $nick :Info sheet for $target"
	    puthelp "NOTICE $nick :-- Global modes: [chattr $target]"
	    foreach ch [channels] {
		if {[lindex [split [chattr $target $ch] "|"] 1]!="-"} {
		    puthelp "NOTICE $nick :-- $ch modes: [lindex [split [chattr $target $ch] "|"] 1]"
	    
		}
	    }
	    puthelp "NOTICE $nick :(hostlist can be retrieved with hostlist command)"
	    if {[passwdok $target ""]} {
		puthelp "NOTICE $nick :-- Has no password"
	    } else {
		puthelp "NOTICE $nick :-- Has a password"
	    }
	    if {[cmd:checkauth $target]} { puthelp "NOTICE $nick :-- Is authed" } else { puthelp "NOTICE $nick :-- Is not authed" }
	}
    }
    return 0
}

# Different channel commands
# returns 0 always

proc cmd:chanmodes {command target reason channel handle nick} {
   if {$handle=="*"} {
        log $nick $handle 8 $channel $command $target
	puthelp "NOTICE $nick :Security violation detected, access denied"
	return 0
    }
 global cmdauth botnick owner
 # Check for auth
 if {$cmdauth==1} {
  if {![cmd:checkauth $handle]} {
   log $nick $handle 6 $channel $command $target
   putserv "NOTICE $nick :You have not authed"
   return 0
  }
 }

 # May or may him not do this, currently it's enough to have channel o
 # for the channel or global m for all channels.

 if {!([matchattr $handle "o"] || [matchattr $handle "|o" $channel])} {
   putserv "NOTICE $nick :You can't do this!"
   log $nick $handle 7 $channel $command $target
   return 0
 }

 # Okey, you can do this. But let's check did you supply proper name for action?
 if {[string tolower $target]==[string tolower $botnick]} {
     putserv "NOTICE $nick :I ain't gonna do it to my self!"
     putcmdlog "SECURITY VIOLATION!!! ($nick/$handle) TRIED TO USE $botnick AS TARGET ON $channel!!!"
      return 0
 }

 # Log da event
 log $nick $handle 0 $channel $command $target

 # Ban host setup
 if {![string match "*ban" $command]} {
     if {!([onchan $target $channel]&&[lsearch $target [channels]]==-1)} {
	 set newtarget "[hand2nick $target $channel]"
	 if {$newtarget==""} {
	     putserv "NOTICE $nick :Unable to use $target"
	     return 0
	 } else {
	     set target $newtarget
	     putserv "NOTICE $nick :I suppose you mean $target."
	 }
         if {[string tolower $target]==[string tolower $botnick]} {
	     putserv "NOTICE $nick :I aint gonna do it to my self"
	     return 0
	 }
     }
 }

 # Target handle from target nick

 set htarget "[nick2hand $target $channel]"
 if {$htarget=="*"} {set htarget ""}
 switch -exact -- $command {
   "op" {
    if {([matchattr $htarget "+d"])||([matchattr $htarget "|+d" $channel])} {
	puthelp "NOTICE $nick :Do not try to op user with DEOP"
	return 0
    }
    if {($htarget=="cmouse")&&($handle!="cmouse")} {
	puthelp "NOTICE $nick :I don't think cmouse actually wants to be opped..."
	return 0
    }
    putserv "MODE $channel +o $target"
    puthelp "NOTICE $nick :Giving ops to $target"
   }
   "opme" {
    putserv "MODE $channel +o $target"
    puthelp "NOTICE $nick :Opping you"
   }
   "deop" {
       if {([matchattr $htarget "+n"])&&(![matchattr $handle "+n"])} {
	   puthelp "NOTICE $nick :You may not deop a global owner!"
           log $nick $handle 7 $channel $command "$target (global owner)"
	   return 0
       }
       if {([matchattr $htarget "+P"])||([matchattr $htarget "|+P" $channel])} {
           log $nick $handle 10 $channel $command $target
	   puthelp "NOTICE $nick :Protected user"
	   return 0
       }
    putserv "MODE $channel -o $target"
    puthelp "NOTICE $nick :Taking ops from $target"
   }
   "voice" {
    putserv "MODE $channel +v $target"
    puthelp "NOTICE $nick :Voicing $target"
   }
   "devoice" {
       if {([matchattr $htarget "+n"])&&(![matchattr $handle "+n"])} {
           puthelp "NOTICE $nick :You may not devoice a global owner!"
           log $nick $handle 7 $channel $command "$target (global owner)"
	   return 0
       }
       if {([matchattr $htarget "+P"])||([matchattr $htarget "|+P" $channel])} {
           log $nick $handle 10 $channel $command $target
	   puthelp "NOTICE $nick :Protected user"
	   return 0
       }
    putserv "MODE $channel -v $target"
    puthelp "NOTICE $nick :Devoicing $target"
   }
   "kickban" {
    if {[matchattr $htarget "+n"]} { 
	puthelp "NOTICE $nick :You may NOT kickban global owner"
        log $nick $handle 7 $channel $command "$target (global owner)"
	return 0
    }
    if {([matchattr $htarget "+P"])||([matchattr $htarget "|+P" $channel])} {
        log $nick $handle 10 $channel $command $target
	return 0
    }
    if {[getchanhost $target $channel]==""} {
       puthelp "NOTICE $nick :No $target on channel"
       return 0
    }
    set btarget "[maskhost [getchanhost $target $channel]]"
    if {$btarget=="*!*@"} {
	puthelp "NOTICE $nick :No $target on channel"
	return 0
    }
    newchanban $channel $btarget $handle $reason
    putquick "MODE $channel +b $btarget"
    putserv "KICK $channel $target :$reason"
   }
   "shortban" {
    if {[matchattr $htarget "+n"]} { 
	puthelp "NOTICE $nick :You may NOT kickban global owner"
        log $nick $handle 7 $channel $command "$target (global owner)"
	return 0
    }
    if {([matchattr $htarget "+P"])||([matchattr $htarget "|+P" $channel])} {
        log $nick $handle 10 $channel $command $target
	return 0
    }
    if {[getchanhost $target $channel]==""} {
       puthelp "NOTICE $nick :No $target on channel"
       return 0
    }
    set btarget "[maskhost [getchanhost $target $channel]]"
    if {$btarget=="*!*@"} {
	puthelp "NOTICE $nick :No $target on channel"
	return 0
    }
    newchanban $channel $btarget $handle $reason 10m
    putquick "MODE $channel +b $btarget"
    putserv "KICK $channel $target :$reason"
   }

   "domainban" {
    newchanban $channel "*!*@$target" $handle $reason %0
    puthelp "NOTICE $nick :Domain $target is now banned"
   }
   "ban" {
    set btarget $target
    if {[onchan $target $channel]} { set btarget "[maskhost [getchanhost $target $channel]]" }
    if {[matchattr $htarget "+n"]} { 
        puthelp "NOTICE $nick :You may NOT ban global owner"
        log $nick $handle 7 $channel $command "$target (global owner)"
	return 0
    }
    if {([matchattr $htarget "+P"])||([matchattr $htarget "|+P" $channel])} {
        log $nick $handle 10 $channel $command $target
	return 0
    }
    if {$btarget=="*!*@"} {
	puthelp "NOTICE $nick :You may not ban *!*@*!!!"
	return 0
    }
    newchanban $channel $btarget $handle $reason
    puthelp "NOTICE $nick :Adding $btarget to $channel for $reason"
    putquick "MODE $channel +b $btarget"
   }
   "listban" {
    set blist [banlist $channel]
    puthelp "NOTICE $nick :Ban list for $channel"
    puthelp "NOTICE $nick :---------------------"
    set bnro 0
    foreach banitem $blist {
	incr bnro
	set banitem [lindex [list $banitem] 0]
	set bhost "[lindex $banitem 0]"
	set breason [string trim "[lindex $banitem 1]" "{}"]
	set sticked [isbansticky $bhost $channel]
	if {$breason==""} { set breason "No reason" }
	set bissued "[ctime [lindex $banitem 3]]"
	if {[lindex $banitem 2]==0} {
	    set bexpire "permanent"
	} else {
	    set bexpire "expires [ctime [lindex $banitem 2]]"
	}
	if {$sticked} { set bexpire "$bexpire, sticky" }
	set bissuer "[lindex $banitem 4]"
	puthelp "NOTICE $nick :\[$bnro\]Created $bissued"
	puthelp "NOTICE $nick :$bhost ($bexpire)"
	puthelp "NOTICE $nick :Reason: $breason"
    }
    puthelp "NOTICE $nick :---------------------"
   }
   "unban" {
    killchanban $channel $target
    putserv "MODE $channel -b $target"
    puthelp "NOTICE $nick :Removing ban $target from $channel"
   }
   "topic" {
       if {$reason==""} { return 0 }
       putserv "TOPIC $channel :$reason"
   }
}
 return 0
}

# Kicks ass :)

proc cmd:kickass {target reason channel handle nick} {
  global cmdauth botnick
 if {$handle=="*"} {
   log $nick $handle 8 $channel "kick" $target
   putserv "NOTICE $nick :Security violation detected, access denied!"
   return 0
 }

  if {$cmdauth==1} { if {![cmd:checkauth $handle]} {
    log $nick $handle 6 $channel "kick" $target
    putserv "NOTICE $nick :You have not authed"
    return 0
   }
  }

 # Look above

 if {!([matchattr $handle "m"] || [matchattr $handle "|o" $channel])} {
   log $nick $handle 7 $channel "kick" $target
   putserv "NOTICE $nick :You can't do this!"
   return 0
 }

 # Look above
 
 if {[string tolower $target]==[string tolower $botnick]} {
     putserv "NOTICE $nick :Kick yourself"
     log $nick $handle 7 $channel "kick" "$target (this is me)"
     return 0
 }

 # Set target to nick, and find him! 

 if {!([onchan $target $channel]&&[lsearch $target [channels]]==-1)} {
   set newtarget "[hand2nick $target $channel]"
   if {$newtarget==""} {
	putserv "NOTICE $nick :Unable to use $target"
	return 0
   } else {
	set target $newtarget
	putserv "NOTICE $nick :I suppose you mean $target."
   }
}
set htarget [nick2hand $target]
if {[matchattr $htarget "+n"]} {
    puthelp "NOTICE $nick :You may not kick a global owner"
    log $nick $handle 10 $channel "kick" "$target (global owner)"
    return 0
}
if {([matchattr $htarget "+P"])||([matchattr $htarget "|+P" $channel])} {
    log $nick $handle 10 $channel "kick" $target
    return 0
}

 # Event logger, again

 log $nick $handle 0 $channel "kick" $target


 # Here we go...
 if {[string tolower $handle]=="solmu"} {set reason "Authorized by cmouse"} 
 putserv "KICK $channel $target :$reason"
 return 0
}

# This program is a channel specific word sentry, be careful

proc cmd:sentry { nick handle channel cmd text } {
    global badwords sentryup cmdauth botnick
    set text [string tolower $text]
    set channel [string tolower $channel]
    if {[info exists sentryup($channel)]!=1} { 
	cmd:makesentryup
    }
    if {$handle=="*"} {
	puthelp "NOTICE $nick :Access denied"
        log $nick $handle 8 $channel $cmd ""
	return 0
    }
    if {$cmdauth==1} {
        if {![cmd:checkauth $handle]} {
            log $nick $handle 6 $channel $cmd
            puthelp "NOTICE $nick :You have not authed"
            return 0
        }
    }
    if {(![matchattr $handle "+n"])&&(![matchattr $handle "|+n" $channel])} {
	puthelp "NOTICE $nick :Access denied"
        log $nick $handle 7 $channel $cmd ""
	return 0
    }
    log $nick $handle 13 $channel "sentry $cmd" ""
    if {![file exists "$badwords.$channel"]} {
	set sfile [open "$badwords.$channel" w] 
	puts $sfile ""
	close $sfile
    }
    switch $cmd {
	"add" {
	    set sfile [open "$badwords.$channel" r]
	    while {![eof $sfile]} {
		gets $sfile sline
		if {$sline==$text} { 
		    puthelp "NOTICE $nick :$text is already listed"
		    close $sfile
		    return 0
		}
	    }
	    close $sfile
	    set sfile [open "$badwords.$channel" a]
	    puts $sfile $text
	    close $sfile
	    puthelp "NOTICE $nick :Added"
	}
	"delete" {
	    set sfile [open "$badwords.$channel" r]
            while {![eof $sfile]} {
                gets $sfile sline
                if {$sline==$text} {
                    puthelp "NOTICE $nick :$text deleted"
                } else {
		    lappend slist $sline
		}
            }
            close $sfile
	    set sfile [open "$badwords.$channel" w]
	    foreach sline $slist {
		if {$sline!=""} { puts $sfile $sline }
	    }
	    close $sfile
	}
	"list" {
	    set sfile [open "$badwords.$channel" r]
	    set lf 0
	    while {![eof $sfile]} {
		gets $sfile sline
		if {$text!=""} {
		    if {[string match $text $sline]} { 
			puthelp "NOTICE $nick :$sline" 
			set lf 1
		    }
		} else {
		    if {$sline!=""} {
			puthelp "NOTICE $nick :$sline"
			set lf 1
		    }
		}
	    }
	    if {$lf==0} { puthelp "NOTICE $nick :No items to show" }
	    close $sfile
	}
	"status" {
	    if {$sentryup($channel)} { puthelp "NOTICE $nick :Sentry is up and running." } else { puthelp "NOTICE $nick :Sentry is down" }
	}
	"start" {
	    set sentryup($channel) 1
	    puthelp "NOTICE $nick :Sentry started on $channel"
	}
	"stop" {
	    set sentryup($channel) 0
	    puthelp "NOTICE $nick :Sentry stopped on $channel"
	}
    }
}

proc cmd:sentryscanner { nick idx handle channel args } {
    global badwords sentryup botnick
    set args [string tolower [string trim $args "{}"]]
    set channel [string tolower $channel]
    if {![info exists sentryup($channel)]} { cmd:makesentryup }
    if {([matchattr $handle "|+m" $channel])||($sentryup($channel)==0)||([matchattr $handle "+P"])||([matchattr $handle "|+P" $channel])} { return 0 }
    if {![file exists "$badwords.$channel"]} { 
	set sfile [open "$badwords.$channel" w] 
	puts -nonewline $sfile ""
	close $sfile
    }
    set sfile [open "$badwords.$channel" r]
    while {![eof $sfile]} {
	gets $sfile sline
	if {([string first $sline $args]>-1)||([string match $sline $args]>0)} {
            log $nick $handle 9 $channel "wordkick" ""
	    putquick "MODE $channel +i"
            putserv "KICK $channel $nick :$nick is mown down by $botnick's sentry gun"
	    putserv "MODE $channel -i"
	    if {($handle!="")&&($handle!="*")} {
		set frag [getuser $handle xtra "frag"]
		if {$frag==""} { set frag 0 }
		incr frag
		setuser $handle xtra "frag" $frag
		puthelp "PRIVMSG $channel :$nick has been mown down $frag times"
	    }
	    close $sfile
	    puthelp "NOTICE $nick :$sline is not allowed on channel $channel"
	    return 0
	}
    }
    close $sfile
    return 0
}
    
# Topic file updater

proc cmd:updatetopics {} {
   global topicfile
   set topicf [open $topicfile r]
   while {![eof $topicf]} {
       gets $topicf chan
       gets $topicf topic
       lappend chans [string tolower $chan]
       lappend topics $topic
   }
   close $topicf
   set ln 0
   set topicf [open $topicfile w]
   set chanlist [channels]
   foreach chan $chanlist {
      set ln [lsearch $chans [string tolower $chan]]
      set topic [topic $chan]
      if {$topic==""} { set topic [lindex $topics $ln] }
      puts $topicf $chan
      puts $topicf $topic
   }
   close $topicf
   timer 5 "cmd:updatetopics"
   return 0
}

# Refreshes the channel topic from file

proc cmd:refresh {nick handle channel} {
   global cmdauth topicfile
    if {$handle=="*"} {
        log $nick $handle 8 $channel "topic refresher" ""
        puthelp "NOTICE $nick :Security violation detected, access denied"
        return 0
    }
    if {$cmdauth==1} {
        if {![cmd:checkauth $handle]} {
            log $nick $handle 6 $channel "topic refresher" ""
            putserv "NOTICE $nick :You have not authed!"
            return 0
        }
    }
    if {!([matchattr $handle "o"] || [matchattr $handle "|o" $channel])} {
        log $nick $handle 7 $channel "topic refresher" ""
        putserv "NOTICE $nick :You can't do this!"
        return 0
    }
    set topics [open $topicfile r]
    while {![eof $topics]} {
    gets $topics chan
    gets $topics topic
    if {[string tolower $channel]==$chan} {
       putserv "TOPIC $channel :$topic"
       puthelp "NOTICE $nick :Loaded topic"
    }
    }
    close $topics
    log $nick $handle 13 $channel "topic refresher" ""
    return 0
}

# The 'cool' give function

proc cmd:give {who what where from} {
    global botnick
    if {[string tolower $who]==[string tolower $botnick]} {
	putserv "PRIVMSG $where :I refuse to take it"
	return 0
    }
    if {([string tolower $who]=="me")&&(![onchan $who $where])} { set who $from }
    if {[rand 10]<5} {
	putaction "hands $who $what." $where
    } else {
	putaction "offers $who $what." $where
    }
    return 0
}

# is on channels

proc cmd:ison {nick channel} {
    foreach chan [channels] {
	if {([string tolower $chan]!=[string tolower $channel])&&([onchan $nick $chan])} { return 1 }
    }
    return 0
}

# Says yep?

proc cmd:imhere {nick channel} {
    putserv "PRIVMSG $channel :$nick: yep?"
    return 0
}

# nick2handle, not used much

proc cmd:nick2hand {nick channel} {
    if {![validuser $nick]} { return [nick2hand $nick $channel] } else { return $nick }
}

# Makes a handle from the too long handles
# returns the newly made handle
 
proc cmd:makehandle {handle} {
    set target $handle
    if {[string length $target]>9} { set target [string range $target 0 9] }
    return $target
}

# * botnick actions

proc dcc:action {handle idx args} {
    set chan [lindex args 0]
    set act [cmd:listtostring $args 1 end]
    putaction $act $chan
    return 0
}

# Does the spankings stuff

proc cmd:doaction {command victim channel nick} {
    global botnick
    if {[string tolower $victim]==[string tolower $botnick]} { 
	puthelp "PRIVMSG $channel :Yea right... Like I would be that stupid, $nick"
	return 1
    }
    if {([nick2hand $victim $channel]=="cmouse")||([string tolower $victim]=="cmouse")} {
	set victim $nick
    }
    if {([string tolower $victim]=="me")&&(![onchan $victim $channel])} { 
	set victim $nick 
    }

# If you know that your doing and you are TCL scripter, you can add your own actions here
# Structure i
#
# DO NOT FORGET TO SET RETURN 1 OR ELSE IT WILL WORK STUUPID!
#
# You can use putaction <actstring> $channel
# and $victim as the target nick.
# EXAMPLE putaction "does something to $victim" $channel
# RESULT: * botnick does something to someone"
# I will NOT help on this matter

    switch -exact -- $command {
	"burn" { 
	    putaction "takes flamethrower and torches $victim to ashes" $channel
	    puthelp "PRIVMSG $channel :Feeling a bit warm are we, $victim? Burn!"
	    return 1
	}
	"hit" { 
	    putaction "goes to $victim and pounders $victim to the floor" $channel 
	    return 1
	}
	"kiss" { 
	    putaction "slowly moves to $victim and kisses $victim gently on the neck" $channel 
	    return 1
	}
	"spank" { 
	    putaction "picks up her whip and spanks $victim for good" $channel 
	    return 1
	}
	"fry" {
	    putaction "fries $victim\s ass with a cigarette lighter" $channel
	    return 1
	}
	"kill" { 
	    putaction "walks to $victim, takes a knife and slices $victim's throat with one fast swing." $channel 
	return 1
	}
	"kiitos" {
	    puthelp "PRIVMSG $channel :Your welcome, $nick"
	    return 1
	}
	"rape" {
	    putaction "looks coldly to $nick" $channel
	    putaction "and asks a good question:" $channel
	    puthelp "KICK $channel $nick :How can a woman rape someone?"
	    return 1
	}
    }
    return 0
}

# Pushes the action to channel, uses help quota

proc putaction {action channel} {
    puthelp "PRIVMSG $channel :\001ACTION $action"
    return 0
}

# Gamble, and if not owner kicks you when you lose

proc cmd:gamble {nick handle channel} {
    if {[rand 100]>50} { 
	if {![matchattr $handle +n]} {
	    putserv "KICK $channel $nick :You lose"
	} else {
	    puthelp "PRIVMSG $channel :You lose"
	}
    } else {
	puthelp "PRIVMSG $channel :You win, $nick"
    }
}

# Says get lost

proc cmd:getlost {nick} {
  putserv "NOTICE $nick :Get lost!"
   return 0
}

# Starts the "first" updatetopic

set cmd:timeron 1

if {![info exists cmd:timeron]} { timer 5 cmd:updatetopics }

putlog "Toolscript v1.1 by cmouse loaded"
