#############################################
# Webstat.tcl 0.1 by #egghelp@efnet (KuNgFo0)
#
catch {unset webstat_chans} 0
catch {unset webstat_logs} 0
catch {unset webstat_loghtml} 0
# Set the next lines as the channels you want to run in
# and the location to place the html files
set webstat_chans(#testchannel1) "/home/me/public_html/testchannel1.html"
set webstat_chans(#testchannel2) "/home/me/public_html/testchannel2.html"
# Set the next lines as the location where you want to place the log files
# (leave "" to not log)
set webstat_logs(#testchannel1) "/home/me/public_html/testchannel1.log"
set webstat_logs(#testchannel2) "/home/me/public_html/testchannel2.log"
# Set the next lines as the urls that point to the logs - MUST start 
# with http:// unless the logs are in the same dir as the htmls
# (leave "" if not going to log)
set webstat_loghtml(#testchannel1) "http://www.mypage.com/testchannel1.log"
set webstat_loghtml(#testchannel2) "http://www.mypage.com/testchannel2.log"
# Set the next line as the minute interval between updates
set webstat_time 2

# Note - for some reason minute timers in this script crash the bot,
# but second timers don't? Contact me if you can figure out this
# phenomenon
if {![string match "*time_webstat*" [utimers]]} {
 utimer [expr $webstat_time * 60] time_webstat
}
foreach chan [array names webstat_logs] {
 if {$webstat_logs($chan) != ""} {
  logfile pjk $chan $webstat_logs($chan)
 }
}

putlog "*** Webstat.tcl 0.1 by #egghelp@efnet loaded"

proc time_webstat {} {
 global webstat_chans webstat_logs webstat_loghtml webstat_time botnick server
 foreach chan [array names webstat_chans] {
  set fileid [open $webstat_chans($chan) w]
  puts $fileid "<meta http-equiv=Refresh content=[expr $webstat_time * 60]>"
  puts $fileid "<html><head><title>IRC Channel $chan</title></head><body>"
  if {(![validchan $chan]) || (![onchan $botnick $chan])} {
   puts $fileid "<center><h3>$chan at [clock format [unixtime]]</h3></center>"
   puts $fileid "<hr>"
   puts $fileid "<br>I am not on the channel"
  } else {
   puts $fileid "<center><h3>$chan at [clock format [unixtime]] through [lindex [split $server :] 0]</h3></center>"
   if {[topic $chan] != ""} {
    puts $fileid "<tr><br>Topic: <b>[topic $chan]</b></tr>"
   }
   puts $fileid "<hr>"
   puts $fileid "<font size=-1>"
   puts $fileid "<table cellspacing=8 cellpadding=6 border=0>"
   set webstat_onicks ""
   set webstat_vnicks ""
   set webstat_nicks ""
   foreach nick [chanlist $chan] {
    if {[isop $nick $chan]} {
     lappend webstat_onicks $nick
    } elseif {[isvoice $nick $chan]} {
     lappend webstat_vnicks $nick
    } else {
     lappend webstat_nicks $nick
    }
   }
   webstat_write [lsort $webstat_onicks] $chan $fileid
   webstat_write [lsort $webstat_vnicks] $chan $fileid
   webstat_write [lsort $webstat_nicks] $chan $fileid
   puts $fileid "</table>"
   puts $fileid "</font>"
   puts $fileid "<hr>"
   puts $fileid "<br><center>\[ <b>[llength $webstat_onicks]</b> oped | <b>[llength $webstat_vnicks]</b> voiced | <b>[llength "$webstat_onicks $webstat_vnicks $webstat_nicks"]</b> total \]</center>"
  }
  if {($webstat_logs($chan) != "") && ($webstat_loghtml($chan) != "")} {
   puts $fileid "<br><center>\[<a href=$webstat_loghtml($chan)>View Log</a>\]</center>"
  }
  puts $fileid "</body></html>"
  close $fileid
 }
 if {![string match "*time_webstat*" [utimers]]} {
  utimer [expr $webstat_time * 60] time_webstat
 }
}

proc webstat_write {nicklist chan fileid} {
 global botnick
 foreach nick $nicklist {
  set webstat_temp "<td>"
  set hand [nick2hand $nick $chan]
  if {[isop $nick $chan]} {
   append webstat_temp @
  } elseif {[isvoice $nick $chan]} {
   append webstat_temp +
  }
  if {[getuser $hand XTRA URL] != ""} {
   append webstat_temp "<a href=[getuser $hand XTRA URL]><b>$nick</b></a>"
  } elseif {[getuser $hand XTRA EMAIL] != ""} {
   append webstat_temp "<a href=Mailto:[getuser $hand XTRA EMAIL]><b>$nick</b></a>"
  } else {
   append webstat_temp "<b>$nick</b>"
  }
  append webstat_temp ![getchanhost $nick $chan]
  if {$nick == $botnick} {
   lappend webstat_temp (me)
  } elseif {[matchattr $hand b]} {
   lappend webstat_temp (bot)
  }
  if {[onchansplit $nick $chan]} {
   lappend webstat_temp \[split\]
  }
  append webstat_temp "</td><td>Join: [lindex [ctime [getchanjoin $nick $chan]] 3]</td><td>Idle: [getchanidle $nick $chan] min</td>"
  if {[getuser $hand INFO] != ""} {
   append webstat_temp "<td>Info: [getuser $hand INFO]</td>"
  }
  puts $fileid "<tr>$webstat_temp</tr>"
 }
}
